﻿package GameLib
{
	import flash.display.Stage;
	import flash.display.Sprite;
	import flash.events.Event;

	/**
	 * 簡易ゲームライブラリ：ウィンドウクラス
	 * @author kazenetu
	 */
	public class GameLib extends Sprite
	{
		protected var _refStage:Stage = null;
		
		/**
		 * コンストラクタ
		 * @param owner 呼び出し元のstageインスタンス
		 */
		public function GameLib(owner:Stage) 
		{
			this._refStage = owner;
			
			//初期化処理を実行
			this.init();

			//ステージから削除されるタイミングで解放イベントを実行する
			addEventListener(Event.REMOVED_FROM_STAGE, removed);
		}

		/**
		 * 解放処理
		 * @param e Eventインスタンス
		 */
		private function removed(e:Event):void
		{
			//解放処理を実行
			this.dest();

			//イベントハンドラを削除
			removeEventListener(Event.REMOVED_FROM_STAGE, removed);

			//呼び出し元のステージの参照を削除
			this._refStage = null;
		}

		/**
		 * 初期化処理
		 * 派生クラスでオーバーライドして実装してください
		 */
		protected function init():void{}

		/**
		 * 解放処理
		 * 派生クラスでオーバーライドして実装してください
		 */
		protected function dest():void { }
		
		/**
		 * ループ処理
		 * 呼び出し元のEvent.ENTER_FRAMEイベントで呼び出してください。
		 * 派生クラスでオーバーライドして実装してください
		 */
		public function run():void{}
	}

}