﻿package GameLib 
{
	import flash.events.Event;
	import flash.net.URLRequest;
	import flash.media.*;

	/**
	 * 簡易ゲームライブラリ：サウンドクラス
	 * @author kazenetu
	 */
	public class SoundClass
	{
		private var _sounds:Object = null;
		
		/**
		 * コンストラクタ
		 */
		public function SoundClass() 
		{
			this._sounds = new Object();
		}

		/**
		 * サウンドファイル(mp3)をロードする
		 * （filePathは読み込んだファイルのキーとなります）
		 * @param	filePath 読み込むサウンドファイルのパス（相対パスもしくは絶対パス）
		 */
		public function load(filePath:String):void {
			if (this._sounds != null) {
				this._sounds[filePath] = new Sound(new URLRequest(filePath));
			}
		}
		
		/**
		 * サウンドファイルを再生する
		 * （自動的に再生は終了します）
		 * @param	filepath サウンドファイルを識別するキー（サウンドファイルのパス（相対パスもしくは絶対パス））
		 */
		public function play(filepath:String):void {
			if (this._sounds == null) {
				return;
			}
			if (this._sounds.hasOwnProperty(filepath) == false) {
				return;
			}
			
			var sound:Sound = this._sounds[filepath];
			sound.play();
		}

		/**
		 * 解放処理
		 * サウンドクラスの利用が終わったら実行してください。
		 */
		public function dispose():void
		{
			if (this._sounds != null) {
				var sound:Sound;
				for (var value:String in this._sounds) {
					if ((sound = this._sounds[value]) != null) {
						sound.close();
					}
					delete this._sounds[value];
				}
				this._sounds = null;
			}
		}
	}

}