﻿package
{
	import flash.display.Stage;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import GameLib.*;

	import flash.text.TextField;
	import flash.events.TextEvent;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	
	/**
	 * ゲームのエントリクラス
	 * こちらのクラスに修正を加えて、ゲームを作ってください。
	 */
	public class GameMain extends GameLib
	{
		//ゲームライブラリ群
		private var _sound:GameLib.SoundClass = null;
		private var _bgm:GameLib.BgmClass = null;
		private var _graphic:GameLib.GraphicClass = null;
		private var _key:GameLib.KeyClass = null;

		//各ファイル名を定数にしています。実際利用される際は削除してください。
		private static const SOUND_TEST:String = "resource/test.mp3";
		private static const BGM_TEST:String = "resource/bgm.mp3";
		private static const GRAPHIC_TEST:String = "resource/test.png";
		
		/**
		 * コンストラクタ
		 * 修正をいれないでください。
		 * @param	owner 呼び出し元（Mainインスタンス）のステージ
		 */
		public function GameMain(owner:Stage) 
		{
			super(owner);
		}
		
		/**
		 * 初期化処理
		 * ゲームループ前に一度だけ実行されます。
		 * 必要な修正を入れてください。
		 */
		protected override function init():void
		{
			//リソース生成
			this._sound = new GameLib.SoundClass();
			this._bgm = new GameLib.BgmClass();
			this._graphic = new GameLib.GraphicClass(this._refStage);
			this._key = new GameLib.KeyClass(this._refStage);
			
			//ここから下に修正をいれてください。
			//サンプルファイルの読み込み
			this._sound.load(SOUND_TEST);
			this._bgm.load(BGM_TEST);
			this._graphic.load(GRAPHIC_TEST);

			//キーボードのキーコード登録
			this._key.addKeyCode(Keyboard.UP);
			this._key.addKeyCode(Keyboard.DOWN);

			//効果音の再生用TextFieldを作成
			var soundTextField:TextField = new TextField();
			soundTextField.text = "Sound Play";
			soundTextField.x = 0;
			soundTextField.y = 0;
			soundTextField.height = 40;
			soundTextField.textColor = 0xFF0000;
			soundTextField.width = 800;
			this._refStage.addChild(soundTextField);
			soundTextField.mouseEnabled = true;
			soundTextField.addEventListener(MouseEvent.CLICK,
				function():void {
					//テキストをクリックすると効果音を再生
					_sound.play(SOUND_TEST);
				});

			//BGMの再生用TextFieldを作成
			var textField:TextField = new TextField();
			textField = new TextField();
			textField.text = "start bgm";
			textField.x = 0;
			textField.y = 30;
			textField.height = 20;
			textField.textColor = 0xFF0000;
			textField.width = 800;
			this._refStage.addChild(textField);
			textField.mouseEnabled = true;
			textField.addEventListener(MouseEvent.CLICK,
				function (e:MouseEvent):void {
					//テキストをクリックするとBGMの再生、停止を繰り返す
					if (_bgm.isPlay) {
						(e.target as TextField).text = "start bgm";
						_bgm.stop();
					}
					else {
						(e.target as TextField).text = "stop  bgm";
						_bgm.play();
					}
				});
		}

		/**
		 * 解放処理
		 * ゲーム終了後（html遷移など）に実行されます。
		 * 解放処理が必要な場合、修正してください。
		 */
		protected override function dest():void
		{
			//リソース解放
			this._sound.dispose();
			this._sound = null;
			this._bgm.dispose();
			this._bgm = null;
			this._graphic.dispose();
			this._graphic = null;
			this._key.dispose();
			this._key = null;

			//ここから下に修正をいれてください。
		}

		/**
		 * ループ処理
		 * 必要な修正を入れてください。
		 */
		public override function run():void
		{
			this._graphic.clear();

			//ここから下に修正をいれてください。
			
			//キー入力チェック
			if (this._key.getKeyState(Keyboard.UP)) {
				testPos.y -= 4;
			}
			if (this._key.getKeyState(Keyboard.DOWN)) {
				testPos.y += 4;
			}
			
			this._graphic.draw(10, 50, 0, 0, 32, 32, GRAPHIC_TEST);//等倍描画

			testRad += Math.PI * 0.0125;
			if (testRad >= Math.PI * 2.0) {
				testRad -= Math.PI * 2.0;
			}
			this._graphic.drawRich(testPos.x, testPos.y, 0, 0, 32, 32, GRAPHIC_TEST, 2, 2, testRad, new ColorTransform(1, 1, 1, 0.5));//高性能描画
			
			//Text出力
			this._graphic.drawText(0, 100, "テキスト表示");
			this._graphic.drawText(0, 120, "テキスト表示2",0xFF0000);
			this._graphic.drawText(0, 140, "サイズを40に設定",0x0000FF,40);
			this._graphic.drawText(0, 180, "改行前\n改行後",0x00FF00);

			//ここから上に修正をいれてください。

			this._graphic.flip();
		}
		//drawRichメソッドのテスト用です。実際利用される際は削除してください。
		private var testRad:Number = 0;
		private var testPos:Point = new Point(50,50);
	}

}