﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.external.ExternalInterface;
	import flash.system.Security;

	import flash.text.TextField;

	import flash.net.*;
	
	/**
	 * エントリクラス
	 * 単にGameLibの派生クラスのインスタンスを作成し、呼び出すだけなので
	 * そのまま変更せずに使ってください。
	 * @author kazenetu
	 */
	public class Main extends Sprite 
	{
		private var gameMain:GameMain = null;
		
		/**
		 * コンストラクタ
		 * FlashDevelopで自動生成されます
		 */
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		/**
		 * 初期化処理
		 * FlashDevelopでスケルトンメソッドが自動生成されます
		 */
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);

			// entry point
			//GameLibの派生クラスのインスタンスを作成、ステージに追加する。
			this.gameMain = new GameMain(this.stage);
			this.addChild(this.gameMain);

			//ループイベントを登録
			addEventListener(Event.ENTER_FRAME, onEnter);

			//ステージ削除イベントを登録
			addEventListener(Event.REMOVED_FROM_STAGE, removedEvent);
			
			//javascriptでunloadイベントを補足し、closeAllメソッドを実行すると確実に解放処理が走ります。
			//必要に応じてコメントを外してください。
			//ExternalInterface.addCallback("closeAll", removed);
		}
		
		/**
		 * 更新処理
		 * @param	e
		 */
		private function onEnter(e:Event):void {
			this.gameMain.run();
		}
		
		/**
		 * ステージ削除イベント
		 * ブラウザによっては実行されない
		 * @param	e
		 */
		private function removedEvent(e:Event):void
		{
			this.removed();
			removeEventListener(Event.REMOVED_FROM_STAGE, removed);
		}

		/**
		 * javascriptで任意に実行できる解放処理
		 */
		public function removed():void
		{
			//ゲームデータの解放
			if(this.gameMain != null){
				this.removeChild(this.gameMain);
				this.gameMain = null;
			}
		}
	}
	
}